﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UniRx;

public class PitchLine : MonoBehaviour
{
	public static PitchLine instance = null;

    public PitchTracker pitchtracker;
    LineRenderer linerenderer;
    public List<Vector3> positions;
    public int iMaxPositions = 100;

	public float db = 0.0f;
	public float fallSpeed = 0.3f;
	public float fallbackSpeed = 2f;

	public bool movePlayerLeft = false;

	//player
	public GameObject player;
	public GameObject wave;


	void Awake()
	{
		if (instance == null)
			instance = this;
		else
			Destroy (gameObject);
	}

	// Use this for initialization
	void Start ()
    {
        linerenderer = GetComponent<LineRenderer>();
        positions = new List<Vector3>();
        //pitchtracker.pitchValue
        //.Throttle(System.TimeSpan.FromMilliseconds(250))
        //.Subscribe(pitchValue => AddNewPoint(pitchValue));
        Debug.Log("start called");
        Observable.EveryUpdate()
        .Sample(System.TimeSpan.FromMilliseconds(25.0))
        .Do(x => Debug.Log("log"))
			.Subscribe(_ => updatePlayer(pitchtracker.dbValue))
        //.Subscribe(_ => AddNewPoint(pitchtracker.pitchValue.Value))
			//pitchtracker.dbValue
        .AddTo(gameObject);
    }
	
	// Update is called once per frame
	void FixedUpdate () {

		float x = player.transform.position.x;
		float y;
		float wavey;


		//for y
		if (db <= 0.0f)
		{

			y = Mathf.Lerp (player.transform.position.y, -4.0f, fallSpeed * Time.deltaTime);
			wavey = Mathf.Lerp (wave.transform.position.y, -10.0f, fallSpeed * Time.deltaTime);

		}
		else 
		{
			if(db >= 10.0f)
				db = 10.0f;
			
			y = Mathf.Lerp (player.transform.position.y, -4.0f + 0.08f * (db * 10), 0.08f);
			wavey = Mathf.Lerp (wave.transform.position.y, -10.0f + 0.08f * (db * 10), 0.08f);
		}

		//for x
		if (movePlayerLeft == true) 
		{
			
			x = player.transform.position.x - World.instance.movement * Time.deltaTime*fallbackSpeed; //1.5

		}

		player.GetComponent<Rigidbody2D >().MovePosition(new Vector2(x,y));
	

		wave.transform.position = new Vector3 (x, wavey  , wave.transform.position.z);
	}



	//player
	void updatePlayer(float pitch)
	{

		db = pitch + 20f ; //+15.0

	}

    void AddNewPoint(float pitch)
    {
        if (positions.Count >= iMaxPositions)
            positions.Clear();
        positions.Add(new Vector3(positions.Count * 10.0f, pitch / 10, 0));
        linerenderer.numPositions = positions.Count;
        linerenderer.SetPositions(positions.ToArray());
    }
}
